/////////////////////////////////////////////////////////////////////////////
// Gamebios.h : Gamebios
/////////////////////////////////////////////////////////////////////////////
#ifndef __GAMEBIOS_H__
#define __GAMEBIOS_H__
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "DxError.h"

/////////////////////////////////////////////////////////////////////////////
// Prototype

#ifndef GBEXPORT
#define GBEXPORT
#endif

#ifdef _DEBUG
#define DEBUG(v)					v;
#define NODEBUG(v)					;
#else
#define DEBUG(v)					;
#define NODEBUG(v)					v;
#endif
#define RELEASE(v)					if (v) { v->Release(); v = NULL; }

#define GBSTARTUP_DEBUGDUMP			(0x00000001)
#define GBSTARTUP_ALLOCTRACE		(0x00000002)

#define GBPIE(v)					(3.141592653589f * (FLOAT)v)
#define GBRAND()					(rand())
#define GBFRAND()					((FLOAT)rand() * (1.0 / RAND_MAX))
#define GBABS(v)					(v < 0 ? -v : v)

#define MULTI_TO_WIDE(v1, v2, v3)	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, v2, -1, v1, v3)
#define WIDE_TO_MULTI(v1, v2, v3)	WideCharToMultiByte(CP_ACP, 0, v2, -1, v1, v3, NULL, NULL)

typedef struct {
    DWORD dwMajorVersion;
	DWORD dwMinorVersion;
	DWORD dwBuildNumber;
} *LPGBVERSIONINFO, GBVERSIONINFO;

typedef struct {
	HWND		hWnd;
	HINSTANCE	hInstance;
	GUID		guidApplication;
	DWORD		dwFlags;
	CHAR		pszDebugDumpFile[_MAX_PATH];
} *LPGBSTARTUPINFO, GBSTARTUPINFO;

GBEXPORT BOOL GBStartup(LPGBSTARTUPINFO pInfo);
GBEXPORT VOID GBCleanup();
GBEXPORT BOOL GBGetVersion(LPGBVERSIONINFO pInfo);
GBEXPORT BOOL GBValidateGBSystems();

GBEXPORT LPVOID GBAlloc(INT nSize);
GBEXPORT LPVOID GBAllocZeroInit(INT nSize);
GBEXPORT LPVOID GBAllocEx(INT nSize, LPSTR pszBlockName);
GBEXPORT LPVOID GBAllocExZeroInit(INT nSize, LPSTR pszBlockName);
GBEXPORT LPVOID GBReAlloc(LPVOID p, INT nSize);
GBEXPORT LPVOID GBReAllocZeroInit(LPVOID p, INT nSize);
GBEXPORT INT  GBSize(LPVOID p);
GBEXPORT VOID GBFree(LPVOID p);

/////////////////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////////////////
