/////////////////////////////////////////////////////////////////////////////
// Gb2d.h : Gamebios 2D
/////////////////////////////////////////////////////////////////////////////
#ifndef __GB2D_H__
#define __GB2D_H__
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "Gamebios.h"
#include "GbVideo.h"

/////////////////////////////////////////////////////////////////////////////
// Prototype

#define GB2DRGB(r, g, b)			GBVIDEORGB(r, g, b)

typedef COLORREF GB2DCOLOR;

#define GB2DDS_STRETCH				(1 <<  1)
#define GB2DDS_ROTATION				(1 <<  2)
#define GB2DDS_BLEND				(1 <<  3)
#define GB2DDS_MIRRORX				(1 <<  4)
#define GB2DDS_MIRRORY				(1 <<  5)

typedef struct {
	INT		nWidth;
	INT		nHeight;
} *LPGB2DBUFFERINFO, GB2DBUFFERINFO;

typedef struct {
	INT   nSrcX;
	INT   nSrcY;
	INT   nSrcW;
	INT   nSrcH;
	INT   nSrcBuffer;
	INT   nDstX;
	INT   nDstY;
	DWORD dwFlags;
} *LPGB2DSPRITE, GB2DSPRITE;

GBEXPORT BOOL GB2DStartup();
GBEXPORT VOID GB2DCleanup();

// Splash

GBEXPORT BOOL GB2DSplashDirectX();
GBEXPORT BOOL GB2DSplashLetSoftware();

GBEXPORT VOID GB2DSetFont(LOGFONT* lfANSI, LOGFONT* lfUNICODE);
GBEXPORT VOID GB2DSetFontSize(FLOAT fW, FLOAT fH);
GBEXPORT VOID GB2DSetTextColor(GB2DCOLOR crText = 0xffffff, GB2DCOLOR crBack = 0, INT nBkMode = TRANSPARENT);
GBEXPORT VOID GB2DSetTextAlign(UINT uTextAlign);
GBEXPORT VOID GB2DGetCurrentTextPosition(INT* nX, INT* nY);

GBEXPORT HDC  GB2DGetDC(INT nBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT BOOL GB2DReleaseDC(HDC hDC, INT nBuffer = GBVIDEO_BACKBUFFER);

//GBEXPORT BOOL GB2DBeginText(FLOAT fX, FLOAT nY, INT nDstBuffer = GB2D_BACKBUFFER);
//GBEXPORT BOOL GB2DBeginText(INT nX, INT nY, INT nDstBuffer = GB2D_BACKBUFFER);
//GBEXPORT VOID GB2DEndText();
GBEXPORT VOID GB2DTextOut(LPCTSTR pszText, INT nLength = 0);

GBEXPORT BOOL GB2DTextOut(FLOAT fX, FLOAT fY, LPCTSTR pszText, INT nDstBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT BOOL GB2DTextOut(INT nX, INT nY, LPCTSTR pszText, INT nDstBuffer = GBVIDEO_BACKBUFFER);

GBEXPORT BOOL GB2DGetTextExtentPoint32(LPCTSTR pszText, FLOAT* pfW, FLOAT* pfH, INT nDstBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT BOOL GB2DGetTextExtentPoint32(LPCTSTR pszText, LPSIZE lpSize, INT nDstBuffer = GBVIDEO_BACKBUFFER);

GBEXPORT VOID GB2DFillRect(CONST LPRECT prect, GBVIDEOCOLOR color = 0, INT nBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT VOID GB2DFillRect(FLOAT fX, FLOAT fY, FLOAT fW, FLOAT fH, GBVIDEOCOLOR color = 0, INT nBuffer = GBVIDEO_BACKBUFFER);

GBEXPORT VOID GB2DSetImeTextPosition(FLOAT fX, FLOAT fY);
GBEXPORT VOID GB2DSetImeTextPosition(INT nX, INT nY);
GBEXPORT VOID GB2DSetImeTextFont(LOGFONT* lfANSI, LOGFONT* lfUNICODE);
GBEXPORT VOID GB2DSetImeTextFontSize(FLOAT fW, FLOAT fH);
GBEXPORT VOID GB2DSetImeTextColor(GB2DCOLOR crText = 0xffffff, GB2DCOLOR crBack = 0, INT nBkMode = TRANSPARENT);

GBEXPORT INT  GB2DCreateBuffer(LPCTSTR pszFile);
GBEXPORT INT  GB2DCreateBuffer(HBITMAP hbitmap);
GBEXPORT BOOL GB2DGetBufferInfo(LPGB2DBUFFERINFO pInfo, INT nBuffer);
GBEXPORT VOID GB2DReleaseBuffer(INT nBuffer);
GBEXPORT VOID GB2DReleaseAllBuffers();

GBEXPORT VOID GB2DReleaseAllResources();

GBEXPORT VOID GB2DDrawSprite(
	INT nSrcX, INT nSrcY, INT nSrcW, INT nSrcH, INT nSrcBuffer,
	INT nDstX, INT nDstY, INT nDstBuffer = GBVIDEO_BACKBUFFER, DWORD dwFlags = 0);
GBEXPORT VOID GB2DDrawSprite(LPGB2DSPRITE pgb2dsprite, INT nDstBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT VOID GB2DDrawSpriteBatch(LPGB2DSPRITE pgb2dsprite, INT nCount, INT nDstBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT VOID GB2DDrawSpriteFastBatch(LPGB2DSPRITE pgb2dsprite, INT nCount,
	INT nSrcBuffer, INT nDstBuffer = GBVIDEO_BACKBUFFER);

GBEXPORT BOOL GB2DDrawImeReq();
GBEXPORT BOOL GB2DDrawIme(INT nDstBuffer = GBVIDEO_BACKBUFFER);

GBEXPORT BOOL GB2DRestoreAllResources();

// DirectX Interface

/////////////////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////////////////
