/////////////////////////////////////////////////////////////////////////////
// Gb3dStruct.h : Gamebios 3D Struct
/////////////////////////////////////////////////////////////////////////////
#ifndef __GB3DSTRUCT_H__
#define __GB3DSTRUCT_H__
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "Gamebios.h"
#pragma warning(disable : 4275)

/////////////////////////////////////////////////////////////////////////////
// GB3DCOLOR Struct

class GBEXPORT GB3DCOLORRGB {
public:
	GB3DCOLORRGB() {}
	GB3DCOLORRGB(FLOAT fR, FLOAT fG, FLOAT fB, FLOAT fA = 0) { r = fR; g = fG; b = fB; a = fA; }
	FLOAT r, g, b, a;
};
typedef GB3DCOLORRGB *LPGB3DCOLORRGB;

/////////////////////////////////////////////////////////////////////////////
// GB3DVECTOR Struct

/*struct GB3DVECTOR : public D3DVECTOR
{
};
*/

#define GB3DVECTOR D3DVECTOR
#define LPGB3DVECTOR LPD3DVECTOR
#define GB3DVERTEX D3DVECTOR
#define LPGB3DVERTEX LPD3DVECTOR

/////////////////////////////////////////////////////////////////////////////
// GB3DMATRIX Struct

typedef struct GBEXPORT tagGB3DMATRIX : D3DMATRIX
{
// ANZX֐
public:

// o֐
public:
	tagGB3DMATRIX& operator = (const tagGB3DMATRIX& mat);
	tagGB3DMATRIX& operator * (const tagGB3DMATRIX& mat);
	GB3DVECTOR& operator * (const GB3DVECTOR& vec);
	VOID SetZero();
	VOID SetIdentity();

	// Set
	VOID SetProjection(const FLOAT proj_near, const FLOAT proj_far, const FLOAT fov);
	VOID SetView(const GB3DVECTOR from, const GB3DVECTOR at, const D3DVECTOR up, const FLOAT roll = 0.0f);
	VOID SetView(tagGB3DMATRIX& camera, FLOAT roll = 0.0f);
	VOID SetRotateX(const FLOAT r);
	VOID SetRotateY(const FLOAT r);
	VOID SetRotateZ(const FLOAT r);
	VOID SetRotateXYZ(const FLOAT rx, const FLOAT ry, const FLOAT rz);
	VOID SetTranslate(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID SetTranslate(const GB3DVECTOR vec)
		{ SetTranslate(vec.x, vec.y, vec.z); }
	VOID SetScale(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID SetScale(const FLOAT size)
		{ SetScale(size, size, size); }
	VOID SetScale(const GB3DVECTOR vec)
		{ SetScale(vec.x, vec.y, vec.z); }
	VOID SetPosition(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID SetPosition(const GB3DVECTOR vec)
		{ SetPosition(vec.x, vec.y, vec.z); }
	VOID SetOrientation(const FLOAT dx, const FLOAT dy, const FLOAT dz, const FLOAT ux, const FLOAT uy, const FLOAT uz);
	VOID SetOrientation(GB3DVECTOR dir, GB3DVECTOR up)
		{ SetOrientation(dir.x, dir.y, dir.z, up.x, up.y, up.z); }
	VOID LookParallely(tagGB3DMATRIX at);

	// Get
	GB3DVECTOR GetPosition();
	GB3DVECTOR GetDirection();
	GB3DVECTOR GetUpDirection();
	VOID GetOrientation(LPGB3DVECTOR pDir, LPGB3DVECTOR pUp);

	// Compute
	VOID RotateX(const FLOAT r);
	VOID RotateY(const FLOAT r);
	VOID RotateZ(const FLOAT r);
	VOID RotateXYZ(const FLOAT rx, const FLOAT ry, const FLOAT rz);
	VOID RevolveX(const FLOAT r);
	VOID RevolveY(const FLOAT r);
	VOID RevolveZ(const FLOAT r);
	VOID RevolveXYZ(const FLOAT rx, const FLOAT ry, const FLOAT rz);
	VOID TranslateByWorld(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID TranslateByWorld(const GB3DVECTOR vec)
		{ Translate(vec.x, vec.y, vec.z); }
	VOID Translate(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID Translate(const GB3DVECTOR vec)
		{ Translate(vec.x, vec.y, vec.z); }
	VOID Size(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID Size(const FLOAT size)
		{ Size(size, size, size); }
	VOID Size(const GB3DVECTOR vec)
		{ Size(vec.x, vec.y, vec.z); }
	VOID Scale(const FLOAT x, const FLOAT y, const FLOAT z);
	VOID Scale(const FLOAT size)
		{ Scale(size, size, size); }
	VOID Scale(const GB3DVECTOR vec)
		{ Scale(vec.x, vec.y, vec.z); }
	VOID Transpose();

	// Copy
	VOID CopyRotate(tagGB3DMATRIX mat);
	VOID CopyTranslate(tagGB3DMATRIX mat);
	VOID CopyScale(tagGB3DMATRIX mat);

	// Transform
	GB3DVECTOR Transform(const FLOAT x, const FLOAT y, const FLOAT z);
	GB3DVECTOR Transform(const GB3DVECTOR vec)
		{ return Transform(vec.x, vec.y, vec.z); }


// oϐ
public:
} *LPGB3DMATRIX, GB3DMATRIX;

/////////////////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////////////////
